/*
    TIHex v0.41
    Copyright (C) 2004 Jonas Gehring
    This programm uses functions from ExtGraph v2.00beta2 and TIChess by TIChessTeam
        
    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

// C Source File
// Created 10.04.04; 18:25:08

#include <tigcclib.h>					// Include all standard header files
#include "tihex.h"						// Include "tihex"-header
#include "extgraph.h"					// Include ExtGraph v2.00beta2 by TIChessTeam

// About screen
void _about(void)
{
	int y = 36; 

	// Draw the 'menu' rectangle with a height of 64
	_drawrect(64);

	// Show the informations (version, author, about Extgraph, URL)
	DrawGrayStrExt(0, y+10, VERSION, A_REVERSE | A_CENTERED, SMALL);
	DrawGrayStrExt(0, y+18, "by saubue", A_REVERSE | A_CENTERED, SMALL);
	DrawGrayStrExt(0, y+30, "powered by ExtGraph", A_REVERSE | A_CENTERED, SMALL);
	DrawGrayStrExt(0, y+38, "v2.00 beta 2", A_REVERSE | A_CENTERED, SMALL);
	DrawGrayStrExt(0, y+50, "www.ticalc.org", A_REVERSE | A_CENTERED, SMALL);
	
	// Wait for keypress
	ngetchx();
}


// Opens the menu
int _menu(void)
{
	int y = 36, x0 = 60, x1 = 64;
	int action = 0;
  //short mode = 0;
	
	drawmenu:
	// Draw the 'menu' rectangle with a height of 64
	_drawrect(64);
	
	DrawGrayStrExt(x0, y+20, "Start new game", A_REVERSE, SMALL);
	// DrawGrayStrExt(x0, y+31, "Undo", A_REVERSE, SMALL);
	DrawGrayStrExt(x0, y+48, "**  More options are planned..  **", A_REVERSE | A_CENTERED, SMALL);
	
	/*DrawGrayStrExt(x0, y+31, "Game mode                  single player", A_REVERSE, SMALL);
	DrawGrayStrExt(x0, y+42, "Vew highscores", A_REVERSE, SMALL);*/
	
	FastDrawGrayLine(x0, y+26, x1, y+26, COLOR_LIGHTGRAY);
	FastDrawGrayLine(x0, y+37, x1, y+37, COLOR_LIGHTGRAY);
	/*FastDrawGrayLine(x0, y+48, x1, y+48, COLOR_LIGHTGRAY);	
	*/
	
  // As long as ENTER and ESC are not pressed do:
  while (action != KEY_ESC && action != KEY_ENTER)
  {
  	// Wait for keypress
  	action = ngetchx();
  	  
  	switch (action)
  	{
 			case KEY_OPTIONS:
 				// Against TI and link play not implement yet
 				/*
 				if (mode == 0)
  			{
  				DrawGrayStrExt(x0, y+31, "Game mode                     two player", A_REPLACE, SMALL);
					DrawGrayStrExt(x0, y+31, "Game mode                     two player", A_REVERSE, SMALL);
					mode = 1;
				}
				else
				{
					DrawGrayStrExt(x0, y+31, "Game mode                  single player", A_REPLACE, SMALL);
					DrawGrayStrExt(x0, y+31, "Game mode                  single player", A_REVERSE, SMALL);
					mode = 0;
				}
 				*/
 				break;
 			
 			
 			case KEY_NEW:
 				// If sure, start new game
 				_redraw();
 				_drawrect(40);
				DrawGrayStrExt(0, 65, "Are you sure to exit current game?", A_REVERSE | A_CENTERED, SMALL);
				if (ngetchx() == KEY_ENTER)
 					return NEW_GAME;
 				
 				_redraw();
 				goto drawmenu;
 				break;
 			
 			/*case KEY_UNDO:
 				// The undo operation
 				return UNDO;
 				break;	*/
   }
	}
	
	return 0;
}


// Waits for a keypress and reacts on it
int _keywait(void)
{
	int x;

	switch (ngetchx())
	{
		case KEY_LEFTX:
			_moveleft();
			break;
		
		case KEY_RIGHTX:
			_moveright();
			break;
		
		case KEY_UPX:
			_moveup();
			break;
		
		case KEY_DOWNX:
			_movedown();
			break;
		
		case KEY_ESC:
			// = s.o. wants to wuit
			return EXIT;
		
		case KEY_ENTER:
			// Set a hex (or coin)
			return _setcoin();
			break;				
		
		case KEY_OPTIONS:
			// Show the options menu
			x = _menu();
			_redraw();
			return x;
			break;
			
		case KEY_ABOUT:
			// Show the 'about screen'
			_about();
			_redraw();
			break;
		
		case KEY_PLUS:
			// Increase Contrast
			OSContrastUp();
			break;
			
		case KEY_MINUS:
			// Decrease Contrast
			OSContrastDn();
			break;
			
		case KEY_OUT:
			// Turn the calc off
			off();
			break;
		
		case KEY_UNDO:
			// do Undo operation
			return UNDO;
			break;
		
		default:
			// else...
			break;
	}
	return 0;
}
